# CMS Builder

This module provides a CLI command that will generate the files required to programatically create CMS blocks.

## Installation

If `packages.pinpointdesigns.co.uk` has not already been added as a repository, add it:

```shell
composer config repositories.pinpoint composer https://packages.pinpointdesigns.co.uk
```

Require the version of the module that you want to use:

```shell
composer require pinpoint/module-cmsbuilder:1.0.0
```

Enable the module:

```shell
php bin/magento module:enable Pinpoint_CmsBuilder
php bin/magento setup:upgrade
```

## Usage

### CMS Blocks

To create a new CMS block, run:

```shell
php bin/magento cms:block:create
```

This will run you through some questions and generate the block using the information you provide.

| Prompt                   | Description                                                                                                                                                                                                          | Example Response                  |
|--------------------------|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|-----------------------------------|
| **All store views?**     | Answering "Y" or "y" will create a block that is enabled in "All Store Views". Answering "N" or "N" will prompt the next question.                                                                                   | Y<br>N                            |
| **Which store views?**   | This question will only be asked if you answered "N" or "n" to the previous question. You can select either one or multiple store views for the block to be shown in. Tab autocompletion is available at this stage. | store_one<br>store_one,store_two  |
| **CMS Block Title**      | The title of the CMS block as it would be entered in the admin area.                                                                                                                                                 | Foo Bar Baz                       |
| **CMS Block Identifier** | The identifier of the CMS block as it would be entered in the admin area.                                                                                                                                            | foo-bar-baz                       |
| **Patch Name**           | This is the name of the data patch that will create the CMS block. This **must** end in `.php`.                                                                                                                      | CmsBlockFooBarBaz.php             |
| **Which module?**        | This lists the modules that are in `app/code`. You can then decide which module you would like the data patch to reside in. Tab autocompletion is available at this stage.                                           | Pinpoint_Theme                    |
| **Template**             | This is the name of the template that will be used to populate the contents of the CMS block. The `adminhtml` scope is used for templates.                                                                           | Pinpoint_Theme::foo/bar/baz.phtml |

## Demo

![Demo](docs/demo.gif)

---

&copy; 2023 Pinpoint Designs
